Factoid - Ohloh API Reference

Avatar
written by Robin Luckey
aug 28 2007

Factoid

A Factoid is a short, high-level bullet point delivering a simple observation about a Project. Factoids are derived from an Analysis, and new Factoids are created for a Project every time a new Analysis is created.

Factoids are generated when Project statistics (team size, project age, or comment ratio) fall outside the typical range. When these statistics have average values, no Factoids are generated.

On the Ohloh web site, Factoids are rendered in the "Ohloh Summary" which appears in the pale blue box near the top of every project page.

A Project has factoids only if Ohloh has downloaded and analyzed its source code.

Properties
id
The unique ID for the Factoid. Factoid IDs change every time the Project is reanalyzed, so it's unwise to store these IDs for long periods.
analysis_id
The unique ID of the analysis used to calculate this factoid.
type
The Factoid type. The possible types are defined below.
description
A short, human-readable description. This is the bullet point text which appears on the Ohloh project page.
severity
An integer from -3 to +3 which rates the relative severity of the factoid. Negative numbers generally indicate bad news, positive numbers generally indicate good news. Ohloh uses these numbers to select icons to display beside the factoids. All factoids of the same type have the save severity.
license_id
If the Factoid is of type FactoidGplConflict, the unique ID of the conflicting license will appear here.
URL

To get a single Factoid:

GET http://www.ohloh.net/projects/{project_id}/factoids/{factoid_id}.xml
Collection URL

To get a list of all current Factoids for a particular Project:

GET http://www.ohloh.net/projects/{project_id}/factoids.xml

The collection request does not support any filtering, sorting or paging. You will always receive the entire collection of factoids, ordered by descending priority.

Factoid Types
FactoidActivityDecreasing
During the last twelve calendar months, there were at least 25% fewer commits to this project than in the prior twelve calendar months.
FactoidActivityIncreasing
During the last twelve calendar months, there were at least 25% more commits to this project than in the prior twelve calendar months.
FactoidAgeYoung
The source control repository is less than 1 year old.
FactoidAgeOld
The source control repository is at least 3 years old.
FactoidAgeVeryOld
The source control repository is at least 5 years old.
FactoidCommentsVeryLow
Compared to all other projects written in the same language, the comment ratio for this project lies in the bottom 10%.
FactoidCommentsLow
Compared to all other projects written in the same language, the comment ratio for this project lies in the bottom 33%.
FactoidCommentsHigh
Compared to all other projects written in the same language, the comment ratio for this project lies in the top 33%.
FactoidCommentsVeryHigh
Compared to all other projects written in the same language, the comment ratio for this project lies in the top 10%.
FactoidTeamSizeZero
No commits were made to this project in the last 12 months.
FactoidTeamSizeOne
Only a single contributor made commits to this project in the last 12 months.
FactoidTeamSizeSmall
Two or three contributors made commits to this project in the last 12 months.
FactoidTeamSizeLarge
Ten or more contributors made commits to this project in the last 12 months.
FactoidTeamSizeVeryLarge
25 or more contributors made commits to this project in the last 12 months.
FactoidGplConflict
This factoid is generated when Ohloh suspects a GPL license in the project source code, as well as another license that may conflict with GPL. This factoid is always simply a warning, and is not a definitive indication of a conflict.
Mainly Written In...

The "Mainly written in" bullet point listed in the "Ohloh Summary" is not technically a factoid. It's determined by the main_language_name property on an analysis.